<?php
/*
	--------------------------------------------
		LGF Referrer Log
		By Charles F. Johnson
		Copyright 2001 LGF Web Design
		All Rights Reserved.
		http://littlegreenfootballs.com

		This file may be freely distributed
		as long as the credits and copyright
		message above remain intact.
	--------------------------------------------
*/

/*
google key word stripping from: http://www.iportal.nano.pl/

additional (google listing) hacks by jennifer @ scriptygoddess.com

*/

// Name of referrer log file
$reflog = 'reflog-google.txt';

// Name of semaphore file
$semaphore = 'semaphore-google.ref';

// Maximum number of referrers to log
$maxref = 50;

// Domain name of this site (minus "http://www.")
$domain = 'YOURSITE.COM';


$google = 'google.com';

// From whence did Bunky come?
$reft = getenv("HTTP_REFERER");


function istatSearch(){
 GLOBAL $HTTP_REFERER;
 $refer=$HTTP_REFERER;

$sr[]=array("wp","szukaj","Wirtualna Polska");
$sr[]=array("poland","query","Poland.com");
$sr[]=array("ahoj","q","Ahoj.pl");
$sr[]=array("altavista","q","Altavista.com");
$sr[]=array("google","q","Google");
$sr[]=array("yoyo","wpis","Yoyo.pl");
$sr[]=array("onet","qt","Onet.pl");
$sr[]=array("hoga","qt","Hoga.pl");
$sr[]=array("arena","qt","Arena.pl");
$sr[]=array("emulti","wyr","Emulti.pl");
$sr[]=array("abacho","q","Abacho");
$sr[]=array("bestoftheweb","q","Best Of The Web");
$sr[]=array("bluewin","q","Bluewin");
$sr[]=array("fireball","q","Fireball");
$sr[]=array("kvasir","q","Kvasir");
$sr[]=array("msn","q","MSN");
$sr[]=array("search","q","Search");
$sr[]=array("infoseek","qt","InfoSeek");
$sr[]=array("acoon","begriff","Acoon");
$sr[]=array("alltheweb","query","All The Web");
$sr[]=array("evision","query","Evision");
$sr[]=array("aol","query","AOL");
$sr[]=array("freenet","query","FreeNet");
$sr[]=array("lycos","query","Lycos");
$sr[]=array("mamma","query","Mamma");
$sr[]=array("big-search","search","Big Search");
$sr[]=array("cypria","search","Cypria");
$sr[]=array("excite","search","Excite");
$sr[]=array("ask","ask","Ask");
$sr[]=array("netscape","search","Netscape");
$sr[]=array("metaspinner","qry","MetSpinner");
$sr[]=array("nbci","keyword","Nbci");
$sr[]=array("web","su","North Ernlight");
$sr[]=array("yahoo","p","Yahoo");
$sr[]=array("szukacz.icm","q","Szukacz-ICM");
$sr[]=array("yandex","text","Yandex.pl");
$sr[]=array("netsprint","qt","netsprint");
$sr[]=array("o2",szukaj,"O2.pl");

// parsuj url'a
$url=parse_url($refer);

// twrz zmienne z zapytania url'a
parse_str($url[query]);

// liczba znanych wyszukiwarek
$ile=count($sr);

// zidentyfikuj wyszukiwarke 
 for($n=0; $n<$ile; $n++)
 {
  if(eregi($sr[$n][0],$refer) && isset($$sr[$n][1])) 
  	{
		$search=$sr[$n][2];
		break;
	}
  }
 
// slowa kluczowe  
if($search)
{

 $srq=$$sr[$n][1];
 $srq = strtolower($srq);
 $sign = array("%22","%23","%24","%25","%26","%27","%2a","%2b","%2c","%5c");
 while(list($keysign,$valuesign)=each($sign)) $srq = str_replace ($valuesign, "", $srq);
 $quest=str_replace ("+", " ", $srq);
 $quest=stripslashes($srq);
 $srq=rawurldecode($srq);
 $ret[1]=$srq;
 $ret[0]=$search;

}
 
  //return $ret;
foreach($ret as $x) {
$ref .= $x;
}
return $ref;
} 




// Cover me. I'm going in.

if (($reft) and (strstr($reft, $google)) ) {	// if there's a referrer, and it's not someone bouncing around this site
$ref = istatSearch();
	$ref .= "\n";								// append a line feed
	$sp = fopen($semaphore, "w");				// open the semaphore file
	if (flock($sp, 2)) {						// lock the semaphore; other processes will stop and wait here
		$rfile = file($reflog);					// read the referrer log into an array
		if ($reft <> $rfile[0]) {				// if this referrer is different from the last one
			if (count($rfile) == $maxref)		// if the file is full
				array_pop($rfile);				// pop the last element
			array_unshift($rfile, $ref);		// push the new referrer onto the front
			$r = join("", $rfile);				// make the array into a string
			$rp = fopen($reflog, "w");			// open the referrer log in write mode
			$status = fwrite($rp, $r);			// write out the referrer URLs
			$status = fclose($rp);				// close the log
		}
	}
	$status = fclose($sp);						// close the semaphore (and release the lock)
}

?>